import { curry2 } from './curry2';
import { curry3 } from './curry3';
import { curry4 } from './curry4';
export function curry5(fn) {
    function curried(a, b, c, d, e) {
        var args = [];
        for (var _i = 5; _i < arguments.length; _i++) {
            args[_i - 5] = arguments[_i];
        }
        switch (arguments.length) {
            case 1:
                return curry4(function (b, c, d, e) { return fn(a, b, c, d, e); });
            case 2:
                return curry3(function (c, d, e) { return fn(a, b, c, d, e); });
            case 3:
                return curry2(function (d, e) { return fn(a, b, c, d, e); });
            case 4:
                return function (e) {
                    var args = [];
                    for (var _i = 1; _i < arguments.length; _i++) {
                        args[_i - 1] = arguments[_i];
                    }
                    return fn.apply(void 0, [a, b, c, d, e].concat(args));
                };
            default:
                return fn.apply(void 0, [a, b, c, d, e].concat(args));
        }
    }
    return curried;
}
//# sourceMappingURL=curry5.js.map