import { apply } from '../apply';
import { curry } from '../curry';
/**
 * Flips the first 2 arguments of a function.
 * @name flip<A, B, C>(fn: (a: A, b: B) => C): Curry2<B, A, C>
 */
export var flip = function flip(f) {
    return curry(function (b, a) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        return apply([a, b].concat(args), f);
    });
};
//# sourceMappingURL=flip.js.map