"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Given a list of arguments and a function, applies the function with
 * the given arguments.
 * @name apply<A>(list: ArrayLike<any>, fn: (...args: Array<any>) => A): A
 */
exports.apply = function (list, f) {
    if (!f)
        return function (f) { return __apply(list, f); };
    return __apply(list, f);
};
function __apply(list, f) {
    switch (list.length) {
        case 0:
            return f();
        case 1:
            return f(list[0]);
        case 2:
            return f(list[0], list[1]);
        case 3:
            return f(list[0], list[1], list[2]);
        case 4:
            return f(list[0], list[1], list[2], list[3]);
        case 5:
            return f(list[0], list[1], list[2], list[3], list[4]);
        default:
            return f.apply(null, list);
    }
}
//# sourceMappingURL=apply.js.map