"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var curry2_1 = require("./curry2");
var curry3_1 = require("./curry3");
function curry4(fn) {
    function curried(a, b, c, d) {
        var args = [];
        for (var _i = 4; _i < arguments.length; _i++) {
            args[_i - 4] = arguments[_i];
        }
        switch (arguments.length) {
            case 1:
                return curry3_1.curry3(function (b, c, d) { return fn(a, b, c, d); });
            case 2:
                return curry2_1.curry2(function (c, d) { return fn(a, b, c, d); });
            case 3:
                return function (d) {
                    var args = [];
                    for (var _i = 1; _i < arguments.length; _i++) {
                        args[_i - 1] = arguments[_i];
                    }
                    return fn.apply(void 0, [a, b, c, d].concat(args));
                };
            default:
                return fn.apply(void 0, [a, b, c, d].concat(args));
        }
    }
    return curried;
}
exports.curry4 = curry4;
//# sourceMappingURL=curry4.js.map