"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Curries a function to `n` arity.
 * @name curryN(arity: number, f: Function): CurriedFunction
 */
exports.curryN = curriedN(2, function (arity, f) { return curriedN(arity, f, []); }, []);
function curriedN(arity, f, previousArgs) {
    if (arity <= 1)
        return f;
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var concatArgs = previousArgs.concat(args);
        if (concatArgs.length >= arity)
            return f.apply(this, concatArgs);
        return curriedN(arity, f, concatArgs);
    };
}
//# sourceMappingURL=index.js.map