"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var apply_1 = require("../apply");
var curry_1 = require("../curry");
/**
 * Flips the first 2 arguments of a function.
 * @name flip<A, B, C>(fn: (a: A, b: B) => C): Curry2<B, A, C>
 */
exports.flip = function flip(f) {
    return curry_1.curry(function (b, a) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        return apply_1.apply([a, b].concat(args), f);
    });
};
//# sourceMappingURL=flip.js.map